/*-------------------------*
 | Directory Stack for DOS |-+
 |      Version 2.00       | |      Copyright (c) 1993, 1997, 1998
 *-------------------------* |                      by altair@m4.people.or.jp
   +-------------------------*/
#include<conio.h>
#include<dir.h>
#include<fcntl.h>
#include<sys\stat.h>
#include<io.h>
#include<stdio.h>
#include<string.h>
#include"dirstack.h"

#define A(b,f)  ((b)*16+(f))

union
{   struct flags s;
    unsigned i;
}flag;

char*fname,*caller="dirscust";
int r=0,v;

static void u(int y,int f)
{   gotoxy(12,y);  textattr(A(CYAN,WHITE));  cputs(f?"  ":"un");
}

static void frame(void)
{   struct
    {   int attr,x,y;
        char*s;
    }*tp,t[]=
    {   {A(LIGHTGRAY,WHITE),7, 5,
         "ͻ"},
        {A(LIGHTGRAY,WHITE),7,19,"\t\t\t\t\tͼ"},
        {A(WHITE,BLUE),23,19,
         " dirscust - ver 2.00 by altair@m4.people.or.jp "},
        {A(BLACK,BLUE),72,19,""},
        {A(BLACK,BLUE), 8,20,
         ""},
        {A(CYAN,WHITE),11,8,"   set pushdsilent "},{A(CYAN,YELLOW),18,8,"p"},
        {A(LIGHTGRAY,DARKGRAY),33,8,"If set, pushd and popd do not print"},
        {A(LIGHTGRAY,DARKGRAY),33,9,"the directory stack."},
        {A(CYAN,WHITE),11,12,"   set dextract    "},{A(CYAN,YELLOW),18,12,"d"},
        {A(LIGHTGRAY,DARKGRAY),33,12,"If set, `pushd +n' extracts the nth"},
        {A(LIGHTGRAY,DARKGRAY),33,13,"directory from the directory stack"},
        {A(LIGHTGRAY,DARKGRAY),33,14,"rather than rotating it to the top."},
        {A(LIGHTGRAY,LIGHTRED),49,12,"n"},{A(LIGHTGRAY,LIGHTRED),65,12,"n"},
        {A(GREEN,YELLOW),19,17," Enter \t Esc "},
        {A(GREEN,WHITE),38,17,"to cancel "},{0,0,0,NULL}
    };
    struct
    {   int x,y,n;
    }*sp,st[]={{12,9,19},{12,13,19},{20,18,7},{34,18,15},{0,0,0}};
    int i;

    for(i=6;i<19;)
    {   gotoxy(7,i++);  textattr(A(LIGHTGRAY,WHITE));
        cputs("                               "
              "                                ");
        textattr(A(BLACK,BLUE));  putch('');
    }
    for(tp=t;tp->s;++tp)
    {   textattr(tp->attr);  gotoxy(tp->x,tp->y);  cputs(tp->s);
    }
    u(8,flag.s.pushdsilent);  u(12,flag.s.dextract);

    for(textattr(A(LIGHTGRAY,DARKGRAY)),sp=st;sp->n;++sp)
    {   gotoxy(sp->x+sp->n-1,sp->y-1);  putch('');  gotoxy(sp->x,sp->y);
        while(--sp->n>=0)
            putch('');
    }
    gotoxy(9,5);  textattr(A(WHITE,BLUE));
    if(r)
        cprintf(" Resident dirstack at %04X:0000 ",resident);
    else
        cprintf(" %s ",fname);
}

static void popup(char*msg)
{   char*cp;
    int x,n,i;

    cp=strrchr(msg,10);
    if(cp)
        *cp=0;

    gotoxy(x=(75-(n=strlen(msg)))/2,12);  textattr(A(BROWN,YELLOW));
    putch('');  for(i=n+3;--i>0;putch(''));  putch('');
    textattr(A(LIGHTGRAY,DARKGRAY));  putch('');

    gotoxy(x,13);  textattr(A(BROWN,YELLOW));  cputs(" ");
    textcolor(LIGHTGREEN);  cputs(msg);
    gotoxy(x+n+2,13);  textcolor(YELLOW);  cputs(" ");
    textattr(A(LIGHTGRAY,DARKGRAY));  putch('');

    gotoxy(x,14);  textattr(A(BROWN,YELLOW));  putch('');
    for(i=n+3;--i>0;putch(''));  putch('');  textattr(A(LIGHTGRAY,DARKGRAY));
    putch('');

    gotoxy(x+1,15);  for(i=n+5;--i>0;putch(''));
}

static void bye(void)
{   _setcursortype(_NORMALCURSOR);
    asm{  push ds;  push ax;  push bx;  push dx;  mov ax,0x40;  mov ds,ax
        mov ah,2;  xor bh,bh;  xor dl,dl;  mov dh,[0x84];  int 0x10
        pop dx;  pop bx;  pop ax;  pop ds
    }
}

#define M(c) if((c)<0)goto oops

int main(int argc,char**argv)
{   unsigned original_flags;
    int i=1;

    while(--argc>0)
        if(**++argv!='-'){
u:          fputs("Usage:\tdirscust [-r]\n",i?stderr:stdout);
            return i;
        }
        if(!*++*argv)
            goto u;

        switch(**argv)
        {   case'r':    r=1;
                        break;

            case'V':    puts("dirscust: Version " VERSION
                             " by altair@m4.people.or.jp\n");
                        return 0;

            case'h':    i=0;
                        goto u;
        }

    if(r)
    {   chkinst();
        flag.i=peek(resident,FLAGS);
    }else
    {   _chkinst();
        if(!(fname=searchpath("dirstack.com")))
        {   fputs("dirscust: Can't find dirstack.com in path\n",stderr);
            return 1;
        }
        i=open(fname,O_RDWR|O_BINARY);
        fnslashify(fname);
        if(i<0){
oops:       perror(fname);
            return 1;
        }
        M(lseek(i,-4,SEEK_END));
        {   char signature[4];
            M(read(i,signature,4));
            if(memcmp(signature,"DiRS",4))
            {   fprintf(stderr,"%s: Incorrect version\n",fname);
                return 1;
            }
        }
        M(lseek(i,3,SEEK_SET));
        M(read(i,&flag,sizeof flag));
    }
    original_flags=flag.i;

#undef M
#define M(c) if((c)<0)goto die

    for(_setcursortype(_NOCURSOR),frame();;)
        switch(getch())
        {   case'\r':   if(original_flags!=flag.i)
                        {   if(!r)
                            {   if(lseek(i,3,SEEK_SET)<0){
die:                                popup(_strerror("Error"));
                                    bye();
                                    return 1;
                                }
                                M(write(i,&flag,sizeof flag));
                                M(close(i));
                            }
                            if(r||resident)
                                poke(resident,FLAGS,flag.i);

                            popup("Configured successfully");
                        }else
                            popup("Not saved because not changed");
done:                   bye();
                        return 0;

            case 27:    popup("Cancelled");
                        goto done;
            case'd':
            case'D':    u(12,flag.s.dextract=!flag.s.dextract);
                        break;
            case'p':
            case'P':    u(8,flag.s.pushdsilent=!flag.s.pushdsilent);
                        break;

            default:    putch('\a');
        }
}
