;	+-------------------------+
;	| Directory Stack for DOS |-+
;	|      Version 2.00	  | |	Copyright (c) 1993, 1997, 1998
;	+-------------------------+ |		by altair@m4.people.or.jp
;	  +-------------------------+
	.model	tiny
	.code
DFTSIZE equ	 768
MAXSTAY equ	2560
;===================
; Macro Definitions
;===================
	include macros.inc
_str	macro	l,s
l:	db	s,13,10
l_&l	equ	$-l
	endm
;==========
; Resident
;==========
	org	2Ch
environment dw	?
	org	5Ch
org21h	dd	?
transient dw	?
stsize	dw	?
	org	80h
param	label	byte
	org	82h
lastdir label	byte
	org	100h
dirstack:jmp	main
;===============
; Configuration
;===============
	db	0,0	;pushdsilent,dextract
;=================
; Int 21h Handler
;=================
	assume	ds:nothing,es:nothing,ss:nothing
int21h: pushf
	if_	ah,e,2Bh,RepInst
	if_	ah,e,3Bh,chdir
int21h0:popf
chain21h:jmp	org21h
;-----------------------------
;    Int 21h Function 2Bh
; DirStack Installation Check
;-----------------------------
;	 AH = 2Bh
;	 CX = 'Di'
;	 DX = 'RS'
;Return: AL = FFh if not installed
;	 AL = 00h if installed
;	 DX = code segment

RepInst:if_	cx,ne,'Di',int21h0
	if_	dx,ne,'RS',int21h0
	popf
	mov	dx,cs
	xor	al,al
	iret
;-----------------------
; Int 21h Function 3Bh
; Set Current Directory
;-----------------------
; This trap-routine to record last directory
;	 AH = 3Bh
;	 DS:DX -> ASCIZ pathname to become current directory (max 64 bytes)
;Return: CF clear if successful
;	    AX destroyed
;	 CF set on error
;	    AX = error code (03h)

	assume	ds:@code
chdir:	popf
	pushs	<ds,ax,dx,si>
	movp	ds,cs
	mov	ah,19h		;Get current default drive
	int	21h		; AL = drive (00h = A:, 01h = B:, etc)
	add	al,'A'
	mov	[lastdir],al
	mov	word ptr[lastdir+1],'\:'

	mov	ah,47h			;Get current directory
	xor	dl,dl			; DL = drive number (00h = default)
	mov	si,offset lastdir+3	; DS:SI -> buffer for ASCIIZ pathname
	int	21h			;
	pops	<si,dx,ax,ds>
	jmp	chain21h	;Pass control to original int 21h
;===========
; Transient
;===========
_transient db	0
verbose db	0

_str	macro	l,s
l:	db	s,13,10
l_&l	equ	$-l
	endm

	_str	usage,<'Usage:',9,'[lh] ',??filename,' [-uV] [<size>]'>
	_str	changed,<??filename,": Can't unload. TSRs must be unloaded Last In, First Out.">

ver	db	??filename,': Version 2.00 by altair@m4.people.or.jp',13,10,'$'
sizeq	db	??filename,': $'
bytes	db	' Bytes directory stack',13,10,'$'
dot	db	'.',0

INSTALLED equ	2
UNLOAD	equ	4
	even	;     0	   2	4      6
ind	dw	install,stat,exit,unload
sw	dw	0
digits	dw	1000,100,10,1
;=================
; Show Stack Size
;=================
showsize:push	ax
	mov	ah,9		;Write string to stdout
	mov	dx,offset sizeq ; DS:DX -> '$'-terminated string
	int	21h		;
	pop	ax
	xor	bx,bx
	mov	si,offset digits
	mov	cx,4
ss0:	xor	dx,dx
	idiv	word ptr[si]
	inc2	si
	push	dx
	or	bx,ax
	jz	ss1
	mov	ah,2		;Write character to stdout
	mov	dl,al		; DL = character to write
	add	dl,'0'		;
	int	21h		;
ss1:	pop	ax
	loop	ss0
	mov	ah,9		;Write string to stdout
	mov	dx,offset bytes ; DS:DX -> '$'-terminated string
	int	21h		;
	ret
;====================
; Installation Check
;====================
	assume	es:@code
chkinst:push	bx
	mov	ah,2Bh		;DirStack installation check
	mov	cx,'Di'		;
	mov	dx,'RS'		;
	int	21h		;
	pop	bx
	or	al,al
quit:	ret
;==============
; Version Info.
;==============
show_version:mov ah,9		;Write string to stdout
	mov	dx,offset ver	; DS:DX -> '$'-terminated string
	int	21h		;
	int	20h		;Terminate program
;=======================
; Get Optional Switches
;=======================
space?	macro	spaces
	if_	al,e,' ',spaces
	if_	al,e, 9,spaces
	endm

feed	macro	spaces,cr
	space?	spaces
	if_	al,e,13,cr
	endm

sw?	macro	char,var,val
	local	lbl
	if_	al,ne,char,lbl
	mov	var,val
	jmp	gs1
lbl	label	near
	endm

getsw:	lods	param
	space?	getsw
	if_	al,ne,'-',quit
	mov	al,[si]
	feed	badsw,badsw
gs1:	lods	param
	feed	getsw,quit
	sw?	'u',sw,UNLOAD
	sw?	'v',verbose,al
	if_	al,e,'V',show_version
	if_	al,e,'h',helpsw
badsw:	stc
helpsw: mov	cx,l_usage
	mov	dx,offset usage ;Continue to the following routine
bye:	mov	ah,40h		;Write
	mov	bx,1		; BX = file handle
	adc	bx,0		; CX = number of bytes to write
	int	21h		; DS:DX -> data to write

	mov	ah,4Ch		;Terminate with return code
	mov	al,bl		;
	dec	al		;
	int	21h		;
;=======================
; Get Numeric Parameter
;=======================
getnum: xor	cx,cx
gn0:	if_	al,e,13,quit
	mov	dx,10
	sub	al,'0'
	jb	badsw
	cmp	al,dl
	jae	badsw
	xchg	ax,cx
	mul	dl
	add	ax,cx
	if_	ax,be,MAXSTAY,gn1
	mov	ax,MAXSTAY
gn1:	mov	cx,ax
	mov	stsize,ax
	lods	param
	jmp	gn0
;=============
; Entry Point
;=============
main:	cld
	mov	si,offset param+1
	call	getsw
	mov	stsize,DFTSIZE
	call	getnum
	dec	si
tail:	lods	param
	space?	tail
	if_	al,ne,13,badsw
	mov	bx,sw
	callif	chkinst,nz,indj
	or	bx,INSTALLED
indj:	jmp	ind[bx]
;=========
; Install
;=========
	assume	es:nothing
install:mov	ax,0D00h
	mov	word ptr param,ax

	mov	transient,offset _transient

	mov	ax,3521h	;Get int 21h vector
	int	21h		;
	movd	org21h,es,bx

	mov	ax,2521h	 ;Set int 21h vector
	mov	dx,offset int21h ;
	int	21h		 ;

	mov	ah,3Bh		;Set current directory
	mov	dx,offset dot	; DS:DX -> ASCIZ pathname
	int	21h		;

	mov	ax,stsize
	add	ax,offset _transient+0Fh
	and	ax,0FFF0h
	if_	ax,b,sp,inst0
	mov	ax,sp
inst0:	push	ax
	sub	ax,offset _transient
	mov	stsize,ax
	if_	verbose,e,0,frenv
	call	showsize

frenv:	mov	ah,49h		;Fre memory
	mov	es,environment	;
	int	21h		;

	pop	dx		;DX = number of bytes to keep resident
	int	27h		;Terminate and stay resident
;==================
; Print Stack Size
;==================
	assume	es:@code
stat:	if_	verbose,e,0,exit
	mov	es,dx
	mov	ax,es:[stsize]
	call	showsize
exit:	int	20h		;Terminate program
;========
; Unload
;========
unload: mov	ax,3521h	;Get int 21h vector
	int	21h		;
	mov	ax,es
	if_	ax,ne,dx,notmine

	mov	ax,2521h	;Set int 21h vector
	lds	dx,es:org21h	;
	int	21h		;

	mov	ah,49h		;Fre memory
	int	21h		;

	int	20h		;Terminate program

notmine:mov	cx,l_changed
	mov	dx,offset changed
	stc
	jmp	bye

	db	'DiRS'		;Signature for the dirscust uty.
	end	dirstack
